void gui() {

  float marginRatioX = 0.01;
  float marginRatioY = 0.1;
  float guiStart = verticalLocation + barWidth/2;
  float guiWidth = height - guiStart;
  float guiY1 = guiStart + marginRatioY*guiWidth;
  float guiY2 = guiStart + (1-marginRatioY)*guiWidth;
  float guiX1 = marginRatioX*width;
  float guiX2 = (1-marginRatioX)*width;

  //fill(colorGradient.get(20,5),220);
  fill(0, 180);
  rect(width/2, guiStart+0.5*(height-guiStart), width, (height-guiStart));

  strokeWeight(1);
  stroke(244);

  //line(0, guiY1, 0, width, guiY1, 0);
  //line(0, guiY2, 0, width, guiY2, 0);
  //line(guiX1, guiStart, 0, guiX1, height, 0);
  //line(guiX2, guiStart, 0, guiX2, height, 0);
  //line(0, (guiY1+guiY2)/2, 0, width, (guiY1+guiY2)/2, 0);
  //line((guiX1+guiX2)/2, guiStart, 0, (guiX1+guiX2)/2, height, 0);
  //line(0.75*guiX1+0.25*guiX2, guiStart, 0, 0.75*guiX1+0.25*guiX2, 0.75*height+0.25*guiStart, 0);

  float place = (1-2*marginRatioY)*guiWidth/8;
  float textX1 = map(1.f/16.f, 0, 1, guiX1, guiX2);
  float textX2 = map(1.f/2.f, 0, 1, guiX1, guiX2);
  float textY[] = new float[8];
  for (int i =0; i<8; i++) 
    textY[i] = guiY1 + (i+0.5)*place;

  textFont(timeFont, int(24.f/1200*height));
  fill(240);
  textAlign(RIGHT, CENTER);
  text("Alpha", textX1, textY[0]);
  text("Time Range", textX1, textY[1]);
  text("Show Period", textX1, textY[2]);
  text("Speed", textX1, textY[3]);
  text("Zoom Ratio", textX1, textY[4]);
  text("View Mode", textX1, textY[5]);
  text("Shape", textX1, textY[6]);
  text("Background", textX1, textY[7]);
  text("Reset",textX1 + 0.1*(guiX2-guiX1) - 16,textY[7]);
  text("Stop",textX1 + 0.1*(guiX2-guiX1) - 16,textY[6]);
  
  textFont(timeFont, int(height*0.6/12));
  textAlign(RIGHT, BOTTOM);
  text("Exposure & Light", guiX2, guiY2-height*0.36/12);
  textFont(timeFont, int(height*0.24/12));
  textAlign(RIGHT, BOTTOM);
  text("In 24 hours, photographs shot around the world.", guiX2, guiY2);

  if (frameCount == 1) {
    float sliderX = map(1.f/16.f, 0, 1, guiX1, guiX2)+10;
    float sliderY[] = new float[5];
    for (int i =0; i<5; i++) sliderY[i] = guiY1 + (i+0.25) *place;
    zoomRatioSlider = cp5.addSlider("zoomRatio")
      .setPosition(sliderX, sliderY[4])
      .setRange(0, 8)
      .setSize(int(0.1*(guiX2-guiX1)), int(0.5*place))
      .setValue(4)
      .setColorActive(#F0F0F0) 
      .setColorForeground(#E0E0E0) 
      .setColorBackground(#2F2F2F)
      .setLabel(" ")
      .setColorValueLabel(#000000)
      .setDefaultValue(3)

      //.setColorValue(int)
      //.setLabelVisible(false); 
      ;
    speedSlider = cp5.addSlider("speedSlider")
      .setPosition(sliderX, sliderY[3])
      .setRange(1, 300)
      .setSize(int(0.1*(guiX2-guiX1)), int(0.5*place))
      .setValue(100)
      .setColorActive(#F0F0F0) 
      .setColorForeground(#E0E0E0) 
      .setColorBackground(#2F2F2F)
      .setLabel(" ")
      .setColorValueLabel(#000000)
      .setDefaultValue(100)
      //.setColorValue(int)
      //.setLabelVisible(false); 
      ;

    hourPeriodSlider = cp5.addSlider("hourPeriodToShow")
      .setPosition(sliderX, sliderY[2])
      .setRange(0, 4)
      .setSize(int(0.1*(guiX2-guiX1)), int(0.5*place))
      .setValue(1)
      .setColorActive(#F0F0F0) 
      .setColorForeground(#E0E0E0) 
      .setColorBackground(#2F2F2F)
      .setLabel(" ")
      .setColorValueLabel(#000000)
      ;

    hourRangeSlider = cp5.addSlider("hourRangeToShow")
      .setPosition(sliderX, sliderY[1])
      .setRange(0, 2)
      .setSize(int(0.1*(guiX2-guiX1)), int(0.5*place))
      .setValue(0.2)
      .setColorActive(#F0F0F0) 
      .setColorForeground(#E0E0E0) 
      .setColorBackground(#2F2F2F)
      .setLabel(" ")
      .setColorValueLabel(#000000)
      ;

    alphaValueSlider = cp5.addSlider("alphaValue")
      .setPosition(sliderX, sliderY[0])
      .setRange(1, 255)
      .setSize(int(0.1*(guiX2-guiX1)), int(0.5*place))
      .setValue(80)
      .setColorActive(#F0F0F0) 
      .setColorForeground(#E0E0E0) 
      .setColorBackground(#2F2F2F)
      .setLabel(" ")
      .setColorValueLabel(#000000)
      ;


    float buttonX1 = map(1.f/16.f, 0, 1, guiX1, guiX2)+10;
    float buttonX2 = buttonX1 + 30;
    float buttonX3 = buttonX2 + 30;
    float buttonY1 = guiY2 - 2.5*place;
    float buttonY2 = guiY2 - 1.5*place;
    float buttonY3 = guiY2 - 0.5*place;
    float buttonSize = 16.f/1200*height;
    
    mode1Button = new Button("rectangle", buttonX1+buttonSize/2, buttonY1, buttonSize, buttonSize, true, 180, 180, 255, 80);
    mode2Button = new Button("rectangle", buttonX2+buttonSize/2, buttonY1, buttonSize, buttonSize, false, 180, 180, 255, 80);
    mode3Button = new Button("rectangle", buttonX3+buttonSize/2, buttonY1, buttonSize, buttonSize, false, 180, 180, 255, 80);

    rectModeButton = new Button("rectangle", buttonX1+buttonSize/2, buttonY2, buttonSize, buttonSize*10/16, true, 180, 180, 255, 80);
    spotModeButton = new Button("circle", buttonX2+buttonSize/2, buttonY2, buttonSize, buttonSize, false, 180, 180, 255, 80);

    backgroundButton = new Button("rectangle", buttonX1+buttonSize/2, buttonY3, buttonSize, buttonSize, true, 180, 180, 255, 80);

    resetButton = new Button("rectangle", sliderX + 0.1*(guiX2-guiX1) - buttonSize/2, buttonY3, buttonSize, buttonSize, true, 180, 180, 255, 80);
    stopButton = new Button("rectangle", sliderX + 0.1*(guiX2-guiX1) - buttonSize/2, buttonY2, buttonSize, buttonSize, false, 180, 180, 255, 80);
    //cp5.addToggle("showBackground")
    //  .setPosition(buttonX1-20, buttonY3-10)
    //  .setSize(40, 20)
    //  .setValue(true)
    //  .setMode(ControlP5.SWITCH)
    //  .setLabel("")
    //  ;


    float knobSize = (guiY2-guiY1)*7/16.f;
    universeTimeKnob = cp5.addKnob("universeTime")
      .setRange(0, 24)
      .setValue(0)
      .setAngleRange(PI*2)
      .setStartAngle(-PI/2)
      .setPosition(map(8.f/16.f, 0, 1, guiX1, guiX2)-knobSize, guiY1)
      .setRadius(knobSize)
      .setNumberOfTickMarks(24)
      .setTickMarkLength(-4)
      //.snapToTickMarks(true)
      .setColorForeground(color(240, 240, 240, 200))
      .setColorBackground(color(80, 80, 80, 80))
      .setColorActive(color(240, 240, 240, 255))
      .setDragDirection(Knob.HORIZONTAL)
      .setViewStyle(Knob.ARC)
      .scrolled(1)
      ;

    universeTimeKnob.getCaptionLabel()
      .toUpperCase(false)
      .set("Universe Time")
      .setFont(new ControlFont(timeFont, 24));
    universeTimeKnob.getValueLabel()
      .toUpperCase(false)
      .setFont(new ControlFont(timeFont, 36));
  }
  rectModeButton.draw();
  spotModeButton.draw();
  mode1Button.draw();
  mode2Button.draw();
  mode3Button.draw();
  backgroundButton.draw();
  resetButton.draw();
  stopButton.draw();
  universeTimeKnob.setValue(universeTime).
    getValueLabel().set(str(int(universeTime)));
}

void speedSlider(float theValue) {
  speed = theValue;
  println("a slider event. setting background to ");
}