class ImageInfo {
  float time;
  float exposureValue;
  float longitude;
  float latitude;
  float viewAngle;
  float red;
  float green;
  float blue;
  String thumbnailUrl;

  color c;
  float x;
  float y;
  float size;

  ImageInfo(float _t, float _EV, float _lon, float _lat, float _va, float _red, float _green, float _blue, String _thumbnailUrl) {
    time = _t;
    exposureValue = _EV;
    longitude = _lon;
    latitude = _lat;
    viewAngle = _va;
    red = _red;
    green = _green;
    blue = _blue;
    thumbnailUrl = _thumbnailUrl;
  }


  void drawInfo(float fc) {
    float hourDiff = map(longitude, -180, 180, -12, 12);
    float distance = abs(fc - time + hourDiff*3600);
    float maxDistance = hourPeriodToShow*3600;

    if (distance < maxDistance && exposureValue!= Float.NaN) {
      if (exposureValue == Float.NaN) exposureValue = 0;
      colorMode(HSB, 255, 255, 255);
      float colorRatio = constrain(map(exposureValue, 3, 10, 0, 1), 0, 1);      
      switch (viewMode) {
      case 1: 
        c = color(map(colorRatio, 0, 1, hue(night), hue(day)+255)%255
          , map(colorRatio, 0, 1, saturation(night), saturation(day))
          , map(colorRatio, 0, 1, brightness(night), brightness(day))
          , alphaValue);
        break;

      case 2: 
        c = colorGradient.get(int(colorRatio*120+360), 5); 
        c = color(hue(c), saturation(c), brightness(c)*2, alphaValue);
        break;

      case 3:
        colorMode(RGB, 255, 255, 255);
        c = color(red, green, blue, alphaValue);
        colorMode(HSB, 255, 255, 255);
        c = color(hue(c), saturation(c)*10, brightness(c), alphaValue);
      }

      x = map(longitude, -180, 180, 0, width);
      y = map(latitude, -90, 90, height, 0);
      size = zoomRatio*viewAngle*pow((maxDistance-distance)/maxDistance, 2);
      fill(c);
      noStroke();
      pushMatrix();
      //translate(0, 0, (time - 7*3600)/360); // for 3d visualize
      float standardViewAngle = 2*atan((43.27/2)/15);
      float whRatio;
      if (viewAngle>standardViewAngle) 
        whRatio = map(viewAngle, standardViewAngle, PI, 1, 5);
      else
        whRatio = map(viewAngle, 0, standardViewAngle, 5, 1 );
      float rectWidth = 4*size*(whRatio/(1+whRatio));
      float rectHeight = 4*size*(1/(1+whRatio));

      if (rectOrSpot) {
        beginShape(QUADS);
        fill(color(hue(c), saturation(c), brightness(c), alphaValue/15));
        vertex(x-rectWidth/2, y-rectHeight/2);
        fill(color(hue(c), saturation(c), brightness(c), alphaValue));
        vertex(x, y-rectHeight/2);
        fill(color(hue(c), saturation(c), brightness(c), alphaValue));
        vertex(x, y+rectHeight/2);
        fill(color(hue(c), saturation(c), brightness(c), alphaValue/15));
        vertex(x-rectWidth/2, y+rectHeight/2);

        fill(color(hue(c), saturation(c), brightness(c), alphaValue));
        vertex(x, y-rectHeight/2);
        fill(color(hue(c), saturation(c), brightness(c), alphaValue/15));
        vertex(x+rectWidth/2, y-rectHeight/2);
        fill(color(hue(c), saturation(c), brightness(c), alphaValue/15));
        vertex(x+rectWidth/2, y+rectHeight/2);
        fill(color(hue(c), saturation(c), brightness(c), alphaValue));
        vertex(x, y+rectHeight/2);

        endShape();
        //rectMode(CENTER);
        //rect(x, y, rectWidth, rectHeight);
      }
      //rectMode(CENTER);
      //rect(x, y, rectWidth, rectHeight);
      else ellipse(x, y, 1.8*size, 1.8*size);
      popMatrix();
      colorMode(RGB);
    }
  }

  String showThumb(int mx, int my, float fc) {
    x = map(longitude, -180, 180, 0, width);
    y = map(latitude, -90, 90, height, 0);
    float hourDiff = map(longitude, -180, 180, -12, 12);
    float distance = abs(fc - time + hourDiff*3600);
    float maxDistance = hourPeriodToShow*3600;

    if ((((x-mx)*(x-mx) + (y-my)*(y-my)) < height/150) & (distance<maxDistance)) {
      println(thumbnailUrl);
      //return loadImage(thumbnailUrl);
      return thumbnailUrl;
    } else return "";
  }
}